/*********************************************************************
 * File:   queue.c  (part of TTYTALK)
 * Author: Victor Volkman
 * Date:   June, 1988
 ********************************************************************/
#include "tty.h"

extern int q_errs, r_errs;
extern QUEUE inq;

void mk_queue()    /* allocate queue and init. pointers */
{
    char *qbuf=NULL;
    unsigned qsize = MAX_QUEUE;
    /* allocate the largest queue possible */
    while (qbuf==NULL && qsize>MIN_QUEUE)
        if ((qbuf=calloc(1,qsize)) == NULL)
            qsize -= MIN_QUEUE;   /* try a smaller queue */

    inq.head = qbuf;   /* dequeue from head */
    inq.tail = qbuf;   /* enqueue to tail   */
    inq.bbuf = qbuf;
    inq.ebuf = qbuf + qsize;
}


int dequeue()   /* called from main() */
{
    char c;

    intsoff();  /* to avoid conflicts */
    c = *inq.head++;
    if (inq.head == inq.ebuf)    /* Head "wraps around" to the */
        inq.head = inq.bbuf;  /* start of the buffer.       */
    intson();
    return (int) c;
}

#ifdef MSC
far interrupt enqueue()
#else
void enqueue()  /* called from interrupt service routine only */
#endif
{
   #ifdef STATUS
    static char a = 'A';
    char far *video;

    video = 0xB8000000;

    *video = a;
    *(video+1) = a;
    a++;
   #endif

   #ifdef MSC
    intson();
   #endif

    *inq.tail = rcv_char();
    if (++inq.tail == inq.ebuf)  /* Tail "wraps around to the */
        inq.tail = inq.bbuf;  /* start of the buffer.      */
    if (inq.tail == inq.head)
        q_errs++;         /* tail has overrun the head */

   #ifdef MSC
    intsoff();
    sendeoi();   /* clear PIC 8259A */
   #endif
}


int chk_queue()  /* called from main() */
{
    int ret;

    intsoff();
    ret = inq.tail != inq.head;  /* Returns TRUE if the queue */
    intson();            /* has any characters left.  */
    return ret;
}
